searchNodes=[{"doc":"RefData is a library for Phoenix projects that lets you provide reference data for your forms (e.g. Gender) without using a database table. It has been written as tool for POC development but can be used in PROD for fields that are common and do not form part of complex queries.","ref":"RefData.html","title":"RefData","type":"behaviour"},{"doc":"Returns a list of data for the provided key. If the json defines grouped data it will return grouped data.Examplesiex(1)&gt; MyRefData.get(&quot;gender&quot;) [ [key: &quot;Male&quot;, value: &quot;Male&quot;], [key: &quot;Female&quot;, value: &quot;Female&quot;], [key: &quot;Non-binary&quot;, value: &quot;non-binary&quot;] ] iex(1)&gt; MyRefData.get(&quot;countries&quot;) [ Asia: [ [key: &quot;Australia&quot;, value: &quot;Australia&quot;], [key: &quot;New Zealand&quot;, value: &quot;New Zealand&quot;] ], Americas: [ [key: &quot;Canada&quot;, value: &quot;Canada&quot;], [key: &quot;USA&quot;, value: &quot;USA&quot;]] ]","ref":"RefData.html#c:get/1","title":"RefData.get/1","type":"callback"},{"doc":"You can pass params to the get function. Keywords availabledisabled: [] - Will return the data with the listed fields disabledExample iex(1)&gt; MyRefData.get(&quot;gender&quot;, disabled: [&quot;Female&quot;]) [[key: &quot;Male&quot;, value: &quot;Male&quot;], [key: &quot;Female&quot;, value: &quot;Female&quot;, disabled: true], [key: &quot;Non-binary&quot;, value: &quot;Non-binary&quot;] ]","ref":"RefData.html#c:get/2","title":"RefData.get/2","type":"callback"},{"doc":"Returns a list of all key values from the underlying data store. It will match the keys used in the individual json filesExamplesiex&gt; RefData.list_all_keys() [&quot;key1&quot;, &quot;key2&quot;]","ref":"RefData.html#c:list_all_keys/0","title":"RefData.list_all_keys/0","type":"callback"},{"doc":"RefData RefData is a library for Phoenix projects that lets you provide reference data for your forms (e.g. Gender) without using a database table. It has been written as tool for POC development but can be used in PROD for fields that are common and do not form part of complex queries.It's primary purpose is supporting the use of Phoenix.HTML.select.The library is a supervised GenServer that starts as its own application when your applications starts. It will hold all of your defined reference data in memory for fast retrieval when needed. Version 0.2.0 is a breaking change see CHANGELOG","ref":"readme.html","title":"RefData","type":"extras"},{"doc":"The package can be installed by adding ref_data to your list of dependencies in mix.exs:def deps do [ {:ref_data, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"RefData - Installation","type":"extras"},{"doc":"RefData defaults to looking for json objects at the root of the project in a directory called ref_data. You can customise the path to your data by adding an entry in your config.exs file.use Mix.Config ... config :ref_data, path: &quot;path/to/your/dir&quot; ...","ref":"readme.html#config","title":"RefData - Config","type":"extras"},{"doc":"RefData supports a number of different definitions. The simplest definitons are a json object that uses the type of reference data as the key and a list of values is generated as a list of key value pairs. RefData will convert the definitions into Maps e.g. { &quot;gender&quot;: [ &quot;Male&quot;, &quot;Female&quot; ] }Is converted into a map and held in state by teh GenServer:%{ name: &quot;gender&quot;, data: [ [key: &quot;Male&quot;, value: &quot;Male&quot;], [key: &quot;Female&quot;, value: &quot;Female&quot;] ] }RefData also supports more descriptive definitions so that you can assign your own key value pairs. E.g. if you wish to support keys with different values you can provide the details: { &quot;name&quot;: &quot;active&quot;, &quot;data&quot;: [ {&quot;key&quot;: &quot;Enable&quot;, &quot;value&quot;: &quot;true&quot;}, {&quot;key&quot;: &quot;Disable&quot;, &quot;value&quot;: &quot;false&quot;} ] }This will be standardised as a map and stored in state:%{ name: &quot;active&quot;, data: [ [key: &quot;Enable&quot;, value: true], [key: &quot;Disable&quot;, value: false] ] }You can also define grouped data by creating a list of key value pairs of data. This can be doen using teh simple json syntax:{ &quot;countries_grouped&quot;: [ { &quot;Asia&quot;: [&quot;Australia&quot;, &quot;New Zealand&quot;]}, { &quot;Americas&quot;: [&quot;Canada&quot;, &quot;USA&quot;]} ] }%{ name: &quot;countries_grouped&quot;, data: [ [ &quot;Oceania&quot;: [key: &quot;Australia&quot;, value: &quot;Australia&quot;], [key: &quot;New Zealand&quot;, value: &quot;New Zealand&quot;], ] [ &quot;Amercias&quot;: [key: &quot;Canada&quot;, value: &quot;Canada&quot;], [key: &quot;USA&quot;, value: &quot;USA&quot;], ] ] }Alternatively, you can use teh more detailed json definition to customise the values:{ &quot;name&quot;: &quot;countries_grouped&quot;, &quot;data&quot;: [ { &quot;Asia&quot;: [ {&quot;key&quot;:&quot;Australia&quot;, &quot;value&quot;: &quot;Aussie&quot;}, {&quot;key&quot;:&quot;New Zealand&quot;, &quot;value&quot;: &quot;Kiwi&quot;}] }, { &quot;Americas&quot;: [ {&quot;key&quot;:&quot;Canada&quot;, &quot;value&quot;: &quot;Canuck&quot;}, {&quot;key&quot;:&quot;USA&quot;, &quot;value&quot;: &quot;Yank&quot;}] } ] }It will produce the standard map using your custom values%{ name: &quot;countries_grouped&quot;, data: [ [ &quot;Oceania&quot;: [key: &quot;Australia&quot;, value: &quot;Aussie&quot;], [key: &quot;New Zealand&quot;, value: &quot;Kiwi&quot;], ] [ &quot;Amercias&quot;: [key: &quot;Canada&quot;, value: &quot;Canuck&quot;], [key: &quot;USA&quot;, value: &quot;Yank&quot;], ] ] }","ref":"readme.html#defining-data","title":"RefData - Defining Data","type":"extras"},{"doc":"Assuming you use RefData in a module named MyApp.MyRefDatadefmodule MyApp.MyRefData do use RefData endMy future plans include integrating GetText and CLDR and the configuration for these features will be in this module. Below are some usage examples:MyRefData.list_all_keys/0 will list all keys for data held in memoryiex(1)&gt; MyRefData.list_all_keys [&quot;months&quot;, &quot;gender&quot;]MyRefData.get/1 given a key it will return a list of data in the format required by Phoenix.HTML.select. If the json defines grouped data it will return the appropriate format.iex(1)&gt; MyRefData.get(&quot;gender&quot;) [ [key: &quot;Male&quot;, value: &quot;Male&quot;], [key: &quot;Female&quot;, value: &quot;Female&quot;], [key: &quot;Non-binary&quot;, value: &quot;Non-binary&quot;] ]iex(1)&gt; MyRefData.get(&quot;countries&quot;) [ Asia: [ [key: &quot;Australia&quot;, value: &quot;Australia&quot;], [key: &quot;New Zealand&quot;, value: &quot;New Zealand&quot;] ], Americas: [ [key: &quot;Canada&quot;, value: &quot;Canada&quot;], [key: &quot;USA&quot;, value: &quot;Usa&quot;]] ]MyRefData.get/2When given a key and a switch you are able to disable data by passing in a list of values to disable.iex(1)&gt; MyRefData.get(&quot;gender&quot;, disabled: [&quot;Female&quot;]) [ [key: &quot;Male&quot;, value: &quot;Male&quot;], [key: &quot;Female&quot;, value: &quot;Female&quot;, disabled: true], [key: &quot;Non-binary&quot;, value: &quot;Non-binary&quot;] ]","ref":"readme.html#using-refdata","title":"RefData - Using RefData","type":"extras"}]